
#include <stdbool.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <xc.h>
#include "pic32def.h"
#include "lib_usb_cdc_dual.h"

/*** DEVCFG0 ***/

#pragma config DEBUG =      ON
#pragma config ICESEL =     ICS_PGx2
#pragma config PWP =        0xff
#pragma config BWP =        OFF
#pragma config CP =         OFF

/*** DEVCFG1 ***/

#pragma config FNOSC =      PRIPLL
#pragma config FSOSCEN =    OFF
#pragma config IESO =       OFF
#pragma config POSCMOD =    HS
#pragma config OSCIOFNC =   OFF
#pragma config FPBDIV =     DIV_1
#pragma config FCKSM =      CSDCMD
#pragma config WDTPS =      PS1048576
#pragma config FWDTEN =     OFF

/*** DEVCFG2 ***/

#pragma config FPLLIDIV =   DIV_4
#pragma config FPLLMUL =    MUL_20
#pragma config FPLLODIV =   DIV_1
#pragma config UPLLIDIV =   DIV_4
#pragma config UPLLEN =     ON

/*** DEVCFG3 ***/

#pragma config USERID =     0xffff
#pragma config FSRSSEL =    PRIORITY_7
#pragma config FMIIEN =     OFF
#pragma config FETHIO =     OFF
#pragma config FCANIO =     OFF
#pragma config FUSBIDIO =   OFF
#pragma config FVBUSONIO =  OFF


void init(void)
{
    sysPerrformanceConfig(80000000);
	INTCONbits.MVEC = 1;		//荞݃}`xN^
	
	USBCDC_init(1, 1);
	
}

/*		CDCʐMPȂI[Ԃɂ
 */
void cdc_transLow(uint8_t ch)
{
	uint8_t *wrBuf, wrBufSize;
	USBCDC_getPutBuf(ch, &wrBuf, &wrBufSize);
	if(wrBuf != NULL){
		uint8_t *rdBuf, rdCnt, i;
		USBCDC_getData(ch, &rdBuf, &rdCnt);
		if(rdCnt != 0){
            memcpy((void*)wrBuf, (void*)rdBuf, rdCnt);
			USBCDC_putData(ch, wrBuf, rdCnt);
			USBCDC_finishGetData(ch);
		}
	}
}

void cdc_trans(void)
{
	cdc_transLow(1);
	cdc_transLow(2);
}

int main(void)
{
    init();

	EI();
	for(;;){
		USBCDC_task();
		cdc_trans();
	}
    return 0;
}
